//{$WARNINGS OFF}
//{$WARN SYMBOL_PLATFORM OFF}
//{$WARN UNIT_PLATFORM OFF}
//=============================================================================
//  TListBox̃XN[o[̖\
//
//-----------------------------------------------------------------------------
//
//  ygpz
//
//  TCg̃AvP[VށCR|[lgCR[hނ́C]ځCρCzz
//  (IWiCϔ)Ȃǂ͑SĎRłDppRłDACgp̋L
//  ڋ`܂DIWî̂pƂ邱Ƃ͋֎~܂D
//  ȂC{TCg̃vOR[hgpƂɂĐCȂ
//  QCɊւĂ҂͈؊֗^Ȃ̂Ƃ܂DD
//
//-----------------------------------------------------------------------------
//
//  yz
//
//  2015N0801 `
//
//-----------------------------------------------------------------------------
//
//  ymFz
//
//  Windows 7 U64(SP1) + Delphi XE(UP1) Pro
//
//  Presented by Mr.XRAY
//  http://mrxray.on.coocan.jp/
//=============================================================================
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TplListBox = class(TListBox)
  private
  @FMaxTextWidth : Integer;
    FMaxTextIndex : Integer;
    FMarginWidth  : Integer;
    procedure Available_Disable_ScrollBars;
    procedure LBAddString(var Message: TMessage); message LB_ADDSTRING;
    procedure LBInsertString(var Message: TMessage); message LB_INSERTSTRING;
    procedure LBDeleteString(var Message: TMessage); message LB_DELETESTRING;
    procedure LBSetItemHeight(var Message: TMessage); message LB_SETITEMHEIGHT;
    procedure SetMaxTextWidth;
  protected
    procedure Resize; override;
    procedure WMNCCalcSize(var Message: TWMNCCalcSize); message WM_NCCALCSIZE;
    procedure CMFontchange(var Message: TMessage); message CM_FONTCHANGED;
  public
    constructor Create(AOwner: TComponent); override;
  end;

  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    ListBox1: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
    plListBox1 : TplListBox;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  StrUtils,
  plChgCompo;

{$R *.dfm}

//=============================================================================
//  tH[쐬̏
//  DupeString̎gpɂusesStrUtilsKv
//=============================================================================
procedure TForm1.FormCreate(Sender: TObject);
var
  i      : Integer;
  LText1 : String;
  LText2 : String;
begin
  Panel1.Caption := '';

  //tH[쐬ɃR|[lg̓ւ
  plListBox1 := TplListBox(ChangeComponent(ListBox1, TplListBox));

  //eXgp̃f[^Zbg
  plListBox1.Items.BeginUpdate;
  for i:= 0 to 19 do begin
    LText1 := Format('%.6d',[i + 1]);
    LText2 := '     ' + LText1 + ' - ' + DupeString(Trim(LText1), 9);
    plListBox1.Items.Add(LText2);
  end;
  plListBox1.Items.EndUpdate;
end;

//=============================================================================
//  SĂ̕ZĂ݂
//  XN[o[̖̊mFp
//=============================================================================
procedure TForm1.Button1Click(Sender: TObject);
var
  i      : Integer;
  LText1 : String;
begin
  for i := 0 to plListBox1.Items.Count - 1 do begin
    LText1 := Format('%.6d',[i + 1]);
    plListBox1.Items[i] := '     ' + LText1 + ' - ' + LText1 + LText1;
  end;
end;

{ TplListBox }

//=============================================================================
//  RgN^
//=============================================================================
constructor TplListBox.Create(AOwner: TComponent);
begin
  inherited;

  FMaxTextWidth := 0;
  FMaxTextIndex := -1;
  FMarginWidth  := 0;
end;

//=============================================================================
//  TplListBoxResize\bh
//  TCYƎIɎs郁\bh
//=============================================================================
procedure TplListBox.Resize;
begin
  inherited;
  Available_Disable_ScrollBars;
end;

//-----------------------------------------------------------------------------
//  LB_ADDSTRING(̒ǉ)bZ[W
//-----------------------------------------------------------------------------
procedure TplListBox.LBAddString(var Message: TMessage);
var
  LText  : String;
  LWidth : Integer;
begin
  inherited;

  Canvas.Font.Assign(Self.Font);
  FMarginWidth  := Canvas.TextWidth('W');

  LText  := PChar(Message.LParam);
  LWidth := Canvas.TextWidth(LText) + FMarginWidth;
  if LWidth > FMaxTextWidth then begin
    FMaxTextWidth := LWidth;
    FMaxTextIndex := Count - 1;
    Perform(LB_SETHORIZONTALEXTENT, FMaxTextWidth, 0);
  end;
  Available_Disable_ScrollBars;
end;

//-----------------------------------------------------------------------------
//  LB_INSERTSTRING(̑})bZ[W
//  ACe̕ύXM\
//-----------------------------------------------------------------------------
procedure TplListBox.LBInsertString(var Message: TMessage);
var
  LIndex : Integer;
  LText  : String;
  LWidth : Integer;
begin
  inherited;

  Canvas.Font.Assign(Self.Font);
  FMarginWidth  := Canvas.TextWidth('W');

  LIndex := Message.LParam;
  LText  := PChar(LIndex);
  LWidth := Canvas.TextWidth(LText) + FMarginWidth;
  if LWidth > FMaxTextWidth then begin
    FMaxTextWidth := LWidth;
    FMaxTextIndex := LIndex;
    Perform(LB_SETHORIZONTALEXTENT, FMaxTextWidth, 0);
  end;
  Available_Disable_ScrollBars;
end;

//-----------------------------------------------------------------------------
//  LB_DELETESTRING(̍폜)bZ[W̏
//-----------------------------------------------------------------------------
procedure TplListBox.LBDeleteString(var Message: TMessage);
var
  LText  : String;
  LWidth : Integer;
begin
  //폜ÕeLXg擾邽߂inherited̑OŎ擾
  LText := Items[Message.WParam];

  inherited;

  LWidth := Canvas.TextWidth(LText) + FMarginWidth;
  if LWidth >= FMaxTextWidth then begin
    SetMaxTextWidth;
  end;
  Available_Disable_ScrollBars;
end;

//-----------------------------------------------------------------------------
//  LB_SETITEMHEIGHT(ACe̍ύX)bZ[W̏
//-----------------------------------------------------------------------------
procedure TplListBox.LBSetItemHeight(var Message: TMessage);
begin
  inherited;
  Available_Disable_ScrollBars;
end;

//-----------------------------------------------------------------------------
//  CM_FONTCHANGED(tHg̕ύX)bZ[W̏
//  XN[̒lύX
//-----------------------------------------------------------------------------
procedure TplListBox.CMFontchange(var Message: TMessage);
begin
  inherited;
  if FMaxTextIndex < 0 then exit;

  Canvas.Font.Assign(Self.Font);
  FMarginWidth  := Canvas.TextWidth('W');
  FMaxTextWidth := Canvas.TextWidth(Items[FMaxTextIndex]) + FMarginWidth;
  Perform(LB_SETHORIZONTALEXTENT, FMaxTextWidth, 0);
  Available_Disable_ScrollBars;
end;

//-----------------------------------------------------------------------------
//  \eLXg̍ő咷(sNZ)擾ăXN[ݒ
//-----------------------------------------------------------------------------
procedure TplListBox.SetMaxTextWidth;
var
  i      : Integer;
@LWidth : Integer;
begin
  FMaxTextWidth := 0;
@for i := 0 to Items.Count - 1 do begin
@@LWidth := Canvas.TextWidth(Items[i]) + FMarginWidth;
@@if (FMaxTextWidth < LWidth) then begin
      FMaxTextWidth := LWidth;
      FMaxTextIndex := i;
    end;
@end;

@//XN[̃XN[ݒ
  //̒NCAg̈̕Z΃XN[o[L
  Perform(LB_SETHORIZONTALEXTENT, FMaxTextWidth, 0);
end;

//-----------------------------------------------------------------------------
//  XN[o[̗L\Ɩ\̐p\bh
//-----------------------------------------------------------------------------
procedure TplListBox.Available_Disable_ScrollBars;
begin
  //XN[o[
  if (Items.Count * ItemHeight) < ClientHeight then begin
    EnableScrollBar(Handle, SB_VERT, ESB_DISABLE_BOTH);
  end else begin
    EnableScrollBar(Handle, SB_VERT, ESB_ENABLE_BOTH);
  end;

  //XN[o[
  if FMaxTextWidth < ClientWidth then begin
    EnableScrollBar(Handle, SB_HORZ, ESB_DISABLE_BOTH);
  end else begin
    EnableScrollBar(Handle, SB_HORZ, ESB_ENABLE_BOTH);
  end;
end;

//=============================================================================
//  WM_NCCALCSIZEbZ[W
//  ƐXN[o[Iɕ\X^CɕύX
//=============================================================================
procedure TplListBox.WMNCCalcSize(var Message: TWMNCCalcSize);
var
  LStyle : Integer;
begin
  LStyle := GetWindowLong(Handle, GWL_STYLE);
  SetWindowLong(Handle, GWL_STYLE, LStyle or WS_VSCROLL or WS_HSCROLL);

  inherited;
end;

end.
